public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Robin H. Johnson" <robbat2@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] proj/netifrc:master commit in: net/
Date: Tue,  5 Jul 2016 18:14:55 +0000 (UTC)	[thread overview]
Message-ID: <1461442675.4a8358aaf9c0048930194e0bbe3d2509d9da4fd0.robbat2@OpenRC> (raw)

commit:     4a8358aaf9c0048930194e0bbe3d2509d9da4fd0
Author:     Emeric Verschuur <emeric <AT> mbedsys <DOT> org>
AuthorDate: Sat Apr 23 20:17:55 2016 +0000
Commit:     Robin H. Johnson <robbat2 <AT> gentoo <DOT> org>
CommitDate: Sat Apr 23 20:17:55 2016 +0000
URL:        https://gitweb.gentoo.org/proj/netifrc.git/commit/?id=4a8358aa

Add L2TPv3 tunnel/session support to iproute2 module

Add L2TPv3 tunnel/session support to iproute2 module:

Example of config to add two L2TPv3 session/two interfaces with a shared tunnel:

l2tptunnel_net1="remote 1.2.3.4 local 1.2.3.5tunnel_id 3 peer_tunnel_id 3 encap ip"
l2tpsession_net1="tunnel_id 3 session_id 3 peer_session_id 3"
config_net1="null"

l2tptunnel_net2="remote 1.2.3.4 local 1.2.3.5 tunnel_id 3 peer_tunnel_id 3 encap ip"
l2tpsession_net2="tunnel_id 3 session_id 4 peer_session_id 4"
config_net2="null"

 net/iproute2.sh | 45 +++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 45 insertions(+)

diff --git a/net/iproute2.sh b/net/iproute2.sh
index 0b2a8d6..825b9b1 100644
--- a/net/iproute2.sh
+++ b/net/iproute2.sh
@@ -318,6 +318,32 @@ iproute2_pre_start()
 		eend $? || return 1
 		_up
 	fi
+	
+	# L2TPv3
+	local l2tpsession=
+	eval l2tpsession=\$l2tpsession_${IFVAR}
+	if [ -n "${l2tpsession}" ]; then
+		ebegin "Creating L2TPv3 tunnel ${IFVAR}"
+		local l2tptunnel=
+		eval l2tptunnel=\$l2tptunnel_${IFVAR}
+		if [ -n "${l2tptunnel}" ]; then
+			local retcode
+			veinfo ip l2tp add tunnel ${l2tptunnel}
+			ip l2tp add tunnel ${l2tptunnel}
+			#a L2TPv3 tunnel can host several sessions (1 session <=> 1 interface)
+			#if $?=2 the tunnel id already exists, just ignore this error
+			#we assume that the existing one have the same property that we want to create...
+			if [ $? -ne 0 ] && [ $? -ne 2 ]; then
+				eend $? || return 1
+			fi
+		fi
+		veinfo ip l2tp add session ${l2tpsession} name "${IFACE}"
+		ip l2tp add session ${l2tpsession} name "${IFACE}"
+		if [ $? -ne 0 ] && [ $? -ne 2 ]; then
+			eend $? || return 1
+		fi
+		_up
+	fi
 
 	# MTU support
 	local mtu=
@@ -424,6 +450,25 @@ iproute2_post_stop()
 			ip tunnel del "${IFACE}"
 			eend $?
 		fi
+		local l2tptuple
+		# Searching for l2tp session associated to ${IFACE}
+		l2tptuple="$(ip l2tp show session | \
+			awk "match(\$0, /^Session ([0-9]+) in tunnel ([0-9]+)\$/, ret) {sid=ret[1]; tid=ret[2]} 
+				match(\$0, /^[ ]*interface name: ${IFACE}\$/) {print sid\":\"tid; exit}")"
+		if [ -n "$l2tptuple" ]; then
+			local l2tpsession_id l2tptunnel_id
+			l2tpsession_id=${l2tptuple%:*}
+			l2tptunnel_id=${l2tptuple#*:}
+			ebegin "Destroying L2TPv3 tunnel ${IFACE}"
+			veinfo ip l2tp del session tunnel_id $l2tptunnel_id session_id $l2tpsession_id
+			ip l2tp del session tunnel_id $l2tptunnel_id session_id $l2tpsession_id
+			if [ -z "$(ip l2tp show session | grep -E "^Session [0-9]+ in tunnel $l2tptunnel_id\$")" ]; then
+				#tunnel $l2tptunnel_id no longer used, destoying it...
+				veinfo ip l2tp del tunnel tunnel_id $l2tptunnel_id
+				ip l2tp del tunnel tunnel_id $l2tptunnel_id
+			fi
+			eend $?
+		fi
 	fi
 }
 


             reply	other threads:[~2016-07-05 18:15 UTC|newest]

Thread overview: 109+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2016-07-05 18:14 Robin H. Johnson [this message]
  -- strict thread matches above, loose matches on Subject: below --
2024-09-29  0:28 [gentoo-commits] proj/netifrc:master commit in: net/ Sam James
2024-09-23 12:02 Sam James
2024-09-09 22:43 Patrick McLean
2024-09-01  9:22 Sam James
2024-09-01  9:21 Sam James
2024-08-28 18:54 Patrick McLean
2024-06-11  0:39 Patrick McLean
2024-06-11  0:39 Patrick McLean
2024-05-23 18:12 Patrick McLean
2023-11-26  5:31 Robin H. Johnson
2023-11-25  4:52 Robin H. Johnson
2023-10-19 22:57 Sam James
2023-09-10 15:15 Sam James
2023-05-29  0:17 Mike Gilbert
2023-04-19 17:14 Robin H. Johnson
2023-04-17  4:35 Sam James
2023-02-12  6:54 Sam James
2023-01-19 18:50 Sam James
2023-01-19 18:50 Sam James
2023-01-17 15:06 Sam James
2023-01-17 15:06 Sam James
2023-01-17 15:06 Sam James
2023-01-15 20:37 Sam James
2023-01-15 14:03 Sam James
2023-01-15 14:03 Sam James
2023-01-15  1:53 Sam James
2023-01-15  1:51 Sam James
2023-01-15  1:51 Sam James
2022-12-25 19:14 Robin H. Johnson
2022-12-25 19:07 Robin H. Johnson
2021-03-31  1:11 Patrick McLean
2021-03-11 16:54 Lars Wendler
2021-03-11 16:54 Lars Wendler
2021-03-11 16:54 Lars Wendler
2021-02-02  8:28 Lars Wendler
2021-01-27 16:55 Lars Wendler
2021-01-27 14:19 Lars Wendler
2021-01-27 14:06 Lars Wendler
2021-01-24 10:37 Lars Wendler
2021-01-18 14:40 Lars Wendler
2021-01-18 13:04 Lars Wendler
2021-01-18 12:33 Lars Wendler
2021-01-18 12:33 Lars Wendler
2021-01-05 14:27 Lars Wendler
2021-01-05 12:46 Lars Wendler
2021-01-05 12:46 Lars Wendler
2020-12-15 20:11 Lars Wendler
2020-06-02 21:54 Robin H. Johnson
2020-05-31  6:05 Robin H. Johnson
2020-05-31  5:42 Robin H. Johnson
2020-05-31  5:29 Robin H. Johnson
2020-05-31  5:29 Robin H. Johnson
2020-05-31  5:13 Robin H. Johnson
2020-05-31  5:13 Robin H. Johnson
2020-01-04  8:06 Robin H. Johnson
2020-01-04  7:59 Robin H. Johnson
2019-07-09 19:59 Ben Kohler
2019-07-09 19:59 Ben Kohler
2019-07-09 17:39 Ben Kohler
2019-04-21  4:11 Robin H. Johnson
2018-07-12  6:25 Robin H. Johnson
2018-07-10 21:11 Jason Donenfeld
2018-01-21 21:59 Robin H. Johnson
2017-11-27 20:22 Robin H. Johnson
2017-11-27 20:22 Robin H. Johnson
2017-11-14 20:48 Robin H. Johnson
2017-11-14 20:48 Robin H. Johnson
2017-10-21 20:56 Robin H. Johnson
2017-06-09 23:59 Robin H. Johnson
2017-06-09 23:55 Robin H. Johnson
2017-06-09 23:52 Robin H. Johnson
2017-06-09 23:52 Robin H. Johnson
2017-01-27 21:54 Robin H. Johnson
2016-10-27  1:23 Robin H. Johnson
2016-10-24 23:16 Robin H. Johnson
2016-10-24 20:58 Robin H. Johnson
2016-10-24 16:49 Robin H. Johnson
2016-10-24  0:25 Robin H. Johnson
2016-10-24  0:23 Robin H. Johnson
2016-10-24  0:23 Robin H. Johnson
2016-10-24  0:04 Robin H. Johnson
2016-10-24  0:04 Robin H. Johnson
2016-10-23 23:50 Robin H. Johnson
2016-10-23 23:50 Robin H. Johnson
2016-10-23 23:50 Robin H. Johnson
2016-10-23 22:39 Robin H. Johnson
2016-10-23 22:39 Robin H. Johnson
2016-10-05 14:42 Robin H. Johnson
2016-07-19 19:59 Robin H. Johnson
2016-07-05 18:14 Robin H. Johnson
2016-07-05 18:14 Robin H. Johnson
2016-07-05 18:09 Robin H. Johnson
2015-11-08 14:33 Robin H. Johnson
2015-11-08 14:30 Robin H. Johnson
2015-05-25 10:04 Mike Frysinger
2015-05-25 10:04 Mike Frysinger
2015-05-25 10:04 Mike Frysinger
2015-05-25 10:01 Mike Frysinger
2015-01-22 23:01 Robin H. Johnson
2015-01-22 23:01 Robin H. Johnson
2014-12-11 18:13 Robin H. Johnson
2014-09-24  6:19 Robin H. Johnson
2014-07-17 17:56 Robin H. Johnson
2014-07-17 17:56 Robin H. Johnson
2014-04-15 18:18 Robin H. Johnson
2013-08-28 16:59 Robin H. Johnson
2013-08-27 20:06 Ian Stakenvicius
2013-08-25  8:17 Robin H. Johnson

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1461442675.4a8358aaf9c0048930194e0bbe3d2509d9da4fd0.robbat2@OpenRC \
    --to=robbat2@gentoo.org \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox